//gps.c
#include "gps.h"
#include "Include/AT91SAM7S256.h"
#include "usart.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define GPSBUFLEN 80
//#define RAW_GPS 

#define TPOFF    *AT91C_PIOA_CODR = AT91C_PIO_PA7;  //set reg to 0 
#define TPON     *AT91C_PIOA_SODR = AT91C_PIO_PA7;  //set reg to 1 

#define GPEOFF    *AT91C_PIOA_CODR = AT91C_PIO_PA19;  //set reg to 0 
#define GPEON     *AT91C_PIOA_SODR = AT91C_PIO_PA19;  //set reg to 1 


//MAIN POINTERS
AT91PS_PIO    g_pPio   = AT91C_BASE_PIOA;
AT91PS_PDC    g_pPDC0  = AT91C_BASE_PDC_US0;
AT91PS_PDC    g_pPDC1  = AT91C_BASE_PDC_US1;
AT91PS_PMC    g_pPMC   = AT91C_BASE_PMC;


extern struct CURRENT_TIME ctime;
extern struct GPS_DATA gps;



char rbuf1[GPSBUFLEN];
char rbuf2[GPSBUFLEN];
char Time[12]; //
char Status[2]; //
char SLatitude[12];  //
char NS[3];                          // 
char SLongitude[12];         // 
char EW[3];                          // 
char CourseTrue[10];                 // 
char Data[12];                               //
char SatCount[4];                    // 
char AltitudaMSL[12];            //
char ViewSat[4];   //
char COG[8];                 //      
char COGstat[4];             //
char Speed[8];                       //
char SpeedAlt[8];    //
char UNUSED[32];                     //,   ,   
char Knot[8];
char *const RMC[]={Time,Status,SLatitude,NS,SLongitude,EW,Knot,CourseTrue,Data,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED};
char *const GGA[]={UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,SatCount,UNUSED,AltitudaMSL,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED};
//char *const GSV[]={UNUSED,UNUSED,ViewSat,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED,UNUSED};
//char *const VTG[]={COG,COGstat, UNUSED,UNUSED,Knot,UNUSED,Speed,UNUSED,UNUSED,UNUSED};
unsigned char GLONAS_COUNT=0;
unsigned char GPS_COUNT=0;
volatile char DataDone=0;
unsigned char DataValid=0;
static unsigned char ComaPoint=0xff;
static unsigned char CharPoint=0;


unsigned Parser(unsigned char data)
{
unsigned int tmp;  
static unsigned char ByteCount=0xff;
static unsigned int MsgType;                                    
static char *MsgTxt=(char*)&MsgType;     
extern unsigned char ComaPoint;
extern unsigned char CharPoint;
//write_char_USART0(data);
if(data=='$'){ByteCount=0;ComaPoint=0xff;MsgTxt=(char*)&MsgType; return(0);} //  
if(ByteCount==0xff) return(0);                                                                     //
ByteCount++;
//                if ((CharPoint > 100) || ( ComaPoint > 100 ))
//                while(1);

if(ByteCount<=1)        return(0);                                                         //
if(ByteCount<6&&ByteCount>1)            // 4  
        {
        *MsgTxt=data;   //                                            
        MsgTxt++;
        return(0);
        }  
if(ByteCount >= 128)
{
    tmp =  ByteCount; 
    ByteCount = 0xff;
    return(1000 + tmp);
}
if((ComaPoint >= 15) && (ComaPoint !=255))
{
    tmp =  ComaPoint; 
    ByteCount = 0xff;
    return(2000 + tmp);
}
if(CharPoint >= 31)
{
    tmp =  CharPoint; 
    ByteCount = 0xff;
    return(3000 + tmp);
}
   
switch(MsgType)
        {
        case    0x434D5250:                             //GPRMC         
//        case    0x434D524E:                             //GNRMC 
                if(data==',') {ComaPoint++;     CharPoint=0;RMC[ComaPoint][0]=0;return(0);}
                if(data=='*') {MsgType=0;return(0);}
                if(ComaPoint > 15)
                {
                  tmp = ComaPoint;
                  ByteCount=0xff;
                  return(4000 + tmp);
                }
                RMC[ComaPoint][CharPoint++]=data;
                RMC[ComaPoint][CharPoint]=0;
                return(0);
        case    0x41474750:                             //PGGA
//        case    0x4147474e:                             //NGGA
                if(data==',')  {ComaPoint++;    CharPoint=0;GGA[ComaPoint][0]=0;return(0);}
                if(data=='*') {MsgType=0;return(0);}
                if(ComaPoint > 15)
                {
                  tmp = ComaPoint;
                  ByteCount=0xff;
                  return(5000 + tmp);
                }
                GGA[ComaPoint][CharPoint++]=data;
                GGA[ComaPoint][CharPoint]=0;
                return(0);
/*        case    0x47545650:             //PVTG
                if(data==',')  {ComaPoint++;    CharPoint=0;VTG[ComaPoint][0]=0;return(0);}
                if(data=='*') {return(0);}
                VTG[ComaPoint][CharPoint++]=data;
                VTG[ComaPoint][CharPoint]=0;
                return(0);
        case    0x4754564e:             //NVTG
                if(data==',')  {ComaPoint++;    CharPoint=0;VTG[ComaPoint][0]=0;return(0);}
                if(data=='*') {return(0);}
                VTG[ComaPoint][CharPoint++]=data;
                VTG[ComaPoint][CharPoint]=0;
                return(0);
        case    0x56534750:             //PGSV          
                if(data==',')  {ComaPoint++;    CharPoint=0;GSV[ComaPoint][0]=0;return(0);}
                if(data=='*')  {GPS_COUNT=atoi(ViewSat);MsgType=0;return(0);}
                GSV[ComaPoint][CharPoint++]=data;
                GSV[ComaPoint][CharPoint]=0;
                return(0);
        case    0x5653474c:             //LGSV          
                if(data==',')  {ComaPoint++;    CharPoint=0;GSV[ComaPoint][0]=0;return(0);}
                if(data=='*') {GLONAS_COUNT=atoi(ViewSat);MsgType=0;return(0);}
                GSV[ComaPoint][CharPoint++]=data;
                GSV[ComaPoint][CharPoint]=0;
                return(0);*/
        default:        ByteCount=0xff;break;
        }       
ByteCount=0xff;
return(0);
}

/*void US1isr(void) 
{
 int i; 
 extern int g_nd, g_flg;
*AT91C_AIC_ICCR = 0x0080;
//status = *AT91C_US1_CSR;
  if(g_flg == 0) 
  {
    g_flg = 1;
    g_pPDC1-> PDC_RNCR = 80;
    g_pPDC1-> PDC_RNPR = (unsigned)rbuf1;
//    g_pPDC0-> PDC_TPR = (unsigned)rbuf1;
//    g_pPDC0-> PDC_TCR = 80;
    for(i = 0; i < 80; i++)
    {
      Parser((unsigned char)rbuf1[i]);
      if( rbuf1[i] == '*' )  GPSConv();       
    }
  }

  else
  {
    g_flg = 0;
    g_pPDC1-> PDC_RNCR = 80;
    g_pPDC1-> PDC_RNPR = (unsigned)rbuf2;
//    g_pPDC0-> PDC_TPR = (unsigned)rbuf2;
//    g_pPDC0-> PDC_TCR = 80;
//    g_pPio->PIO_CODR = BIT8;  //set reg to 0 (led2 on)
    for(i = 0; i < 80; i++)
    {
      Parser((unsigned char)rbuf2[i]);
      if( rbuf2[i] == '*' )  GPSConv();       
    }
//    g_pPio->PIO_SODR = BIT8;  //set reg to 1 (led2 off)
    g_nd = 1;
  }
}
*/


void US1isr(void) 
{ 
  extern char g_nd, g_flg;
  *AT91C_AIC_ICCR = 0x0080;
//status = *AT91C_US1_CSR;
//  TPON
  if(g_flg == 0) 
  {
    g_flg = 1;
    g_pPDC1-> PDC_RNCR = GPSBUFLEN;
    g_pPDC1-> PDC_RNPR = (unsigned)rbuf1;
#ifdef RAW_GPS    
    g_pPDC0-> PDC_TPR = (unsigned)rbuf1;
    g_pPDC0-> PDC_TCR = GPSBUFLEN;
#endif    
  }
  else
  {
    g_flg = 0;
    g_pPDC1-> PDC_RNCR = GPSBUFLEN;
    g_pPDC1-> PDC_RNPR = (unsigned)rbuf2;
#ifdef RAW_GPS    
    g_pPDC0-> PDC_TPR = (unsigned)rbuf2;
    g_pPDC0-> PDC_TCR = GPSBUFLEN;
#endif    
//    g_pPio->PIO_CODR = BIT8;  //set reg to 0 (led2 on)
//    g_pPio->PIO_SODR = BIT8;  //set reg to 1 (led2 off)
  }
  g_nd = 1;
//  TPOFF
}


/*void US1isr(void) 
{ 
  extern int g_nd, g_flg;
  extern char rbuf1[85], rbuf2[85];
*AT91C_AIC_ICCR = 0x0080;
//status = *AT91C_US1_CSR;
    g_pPDC1-> PDC_RCR = 80;
    g_pPDC1-> PDC_RPR = (unsigned)rbuf1;
//    g_pPDC0-> PDC_TPR = (unsigned)rbuf1;
//    g_pPDC0-> PDC_TCR = 80;
    g_nd = 1;
}
*/

void GPS_Init(void) 
{
char string[32];


  
  *AT91C_PMC_PCER = 0x00000086;   // enable clocks for periferials
  *AT91C_AIC_IECR = 0x00000082; 
  
  
 /*disable GSV*/
    sprintf((char*)string, "$PSRF103,03,00,00,01*27\r\n");
    write_str_USART1((unsigned char*)string);  
//    write_str_USART0((unsigned char*)string);  
/*disable GSA*/
    sprintf((char*)string, "$PSRF103,02,00,00,01*26\r\n");
    write_str_USART1((unsigned char*)string);  
//    write_str_USART0((unsigned char*)string);  
/*enable VTG*/
//    sprintf((char*)string, "$PSRF103,05,00,01,01*20\r\n");
//    write_str_USART1((unsigned char*)string);  
//    write_str_USART0((unsigned char*)string);  

/*disable VTG*/
//    sprintf((char*)string, "$PSRF103,05,00,00,01*21\r\n");
//    write_str_USART1((unsigned char*)string);  
//    write_str_USART0((unsigned char*)string);  
    
  AT91C_AIC_SMR[7]   = 1 | AT91C_AIC_SRCTYPE_INT_HIGH_LEVEL;
  AT91C_AIC_SVR[7]   = (unsigned)US1isr;  
  *AT91C_US1_IER = 0x0008;
//  *AT91C_AIC_DCR = 0x0;     // protected mode enable 
 
  //initialization ints for PDC UART1
  g_pPDC1-> PDC_RPR = (unsigned)rbuf1;
  g_pPDC1-> PDC_RNPR = (unsigned)rbuf2;
  g_pPDC1-> PDC_RCR =  GPSBUFLEN;
  g_pPDC1-> PDC_RNCR = GPSBUFLEN;
  
  
}

unsigned GPSProcessing(void)
{ char j;
  unsigned rt;
  extern char g_nd, g_flg;
//  GPEON
  if( g_flg == 1 )
  {
    for(j = 0; j < GPSBUFLEN; j++)
    {
      rt = Parser((unsigned char)rbuf1[j]);
      if(rt != 0) return(rt);
      else if( rbuf1[j] == '*' ) GPSConv();       
    }
  }
  else
  {
    for(j = 0; j < GPSBUFLEN; j++)
    {
      rt = Parser((unsigned char)rbuf2[j]);
      if(rt != 0) return(rt);
      else if( rbuf2[j] == '*' ) GPSConv();       
    }
  }
  //GPEOFF
  return(rt);
}

void GPSConv(void)
{ char str[16];
       if((Status[0] != 'V')&&(Status[0] != 'A')) return;
       str[2] = 0; 
       strncpy(str, Data, 2);  
       ctime.day   = atoi(str);
       strncpy(str, Data+2, 2);  
       ctime.month   = atoi(str);
       strncpy(str, Data+4, 2);  
       ctime.year   = atoi(str) + 2000;
       strncpy(str, Time, 2);  
       ctime.hour   = atoi(str) + GMT;
       if( ctime.hour  >= 24 )
       {
         ctime.hour -= 24;
         ctime.day++;
         if((ctime.day == 32) ||
           ((ctime.day == 31) && (ctime.month == 4)) ||    
           ((ctime.day == 31) && (ctime.month == 6)) ||    
           ((ctime.day == 31) && (ctime.month == 9)) ||    
           ((ctime.day == 31) && (ctime.month == 11)) ||
           ((ctime.day == 30) && (ctime.month == 2) && (ctime.year%4 == 0)) ||
           ((ctime.day == 29) && (ctime.month == 2) && (ctime.year%4 != 0)))
           {
             ctime.day = 1;
             ctime.month++;
             if( ctime.month == 13 ) 
             {
               ctime.month = 1;
               ctime.year++;
             }
           }
       }
       else if (ctime.hour == 0xFF)
       {
         ctime.hour += 24;
         ctime.day--;
         if(ctime.day == 0)
         {
           if(( ctime.month == 2) ||
              ( ctime.month == 4) ||
              ( ctime.month == 6) ||
              ( ctime.month == 8) || 
              ( ctime.month == 9) ||
              ( ctime.month == 11) ||
              ( ctime.month == 1 )) ctime.day = 31;
           else if(( ctime.month == 2 ) && ( ctime.year%4 == 0 )) ctime.day = 29; 
           else if(( ctime.month == 2 ) && ( ctime.year%4 != 0 )) ctime.day = 28; 
           else ctime.day = 30;
           ctime.month--;
           if( ctime.month == 0 )
           {
             ctime.month = 12;
             ctime.year--;
           }
         } 
       } 
       strncpy(str, Time+2, 2);  
       ctime.minute   = atoi(str);
       strncpy(str, Time+4, 2);  
       ctime.secunde   = atoi(str);
       
       gps.status = Status[0];
       gps.SatCount = atoi(SatCount);

       strncpy(str, SLatitude, 2);  
       gps.Latitude  = (double)atoi(str) + (atof(SLatitude + 2))/60;
       if( NS[0] == 'S') gps.Latitude = -gps.Latitude; 
       
       str[3] = 0;
       strncpy(str, SLongitude, 3);  
       gps.Longitude  = (double)atoi(str) + (atof(SLongitude + 3))/60;
       if( EW[0] == 'W') gps.Longitude = -gps.Longitude; 
       
       gps.Altitude = atof(AltitudaMSL);
       gps.Heading  = atof(CourseTrue);
       gps.Speed    = atof(Knot);

}
