/***** Maxim Generalov,  09-2009 *********************************/
/*  fat.c fat-12 for mmc card tested on 16MB. It use             */
/*  mmc.c, mmc.h by Rolf Freitag 5/2003                          */
/*****************************************************************/
/* Version 2 : added processing for hidden sectors 17/09/2016   */
/* Version 2.1 : Patched end of write at '\0' symbol 30/09/2016                                                             */
/*****************************************************************/

#include "fat.h"
#include "mmc.h"
#include "gps.h"
#include "stdio.h"
#include "string.h"





int fileSearch(char * file_name);
int freeClustSearch( int StartCluster );
int fileCreate( char * file_name);
int markCluster(int cluster_number, unsigned claster_value);
int clValue(int cluster_number);


// external buffer which is use to read/write in MMC card
extern char mmc_buffer[512];
extern struct CURRENT_TIME ctime;
struct tFILE fp[10];

//char tmp_buffer[512];
char fat_buffer[512];
int used_fat_sector=-1; 
struct BOOT_SECT b;

/*DEBUG***********************************/
//int w0=0, w1=0;
/*DEBUG***********************************/

int fatInit(void)
{   int i;
 // Search and Read first Block back to buffer
    memset(&mmc_buffer,0x00,512);
//    mmcReadBlock(0,512);
    
    
    for(i = 0; i < 65535 ; i++)
    {  
      if(mmcReadBlock(i << 9,512) != 0) return(-1);
      if((mmc_buffer[510] == 0x55) &&
      (mmc_buffer[511] == 0xAA) &&
      (mmc_buffer[54]  == 0x46) &&
      (mmc_buffer[55]  == 0x41) &&
      (mmc_buffer[56]  == 0x54) &&
      (mmc_buffer[57]  == 0x31) &&
      (mmc_buffer[58]  == 0x32))  
      {
         //mmc_buffer[28] = 0;
         //mmcWriteBlock(0);    
        
        b.SectSize = mmc_buffer[11] | (mmc_buffer[12] << 8); 
        b.ClustSize = mmc_buffer[13];
        b.ResSecs =( mmc_buffer[14] | (mmc_buffer[15] << 8)) + mmc_buffer[28]; 
        b.FatCnt = mmc_buffer[16]; 
        b.RootSize = mmc_buffer[17] | (mmc_buffer[18] << 8); 
        b.TotSecs = mmc_buffer[19] | (mmc_buffer[20] << 8); 
        b.FatSize = mmc_buffer[22] | (mmc_buffer[23] << 8); 
        b.RootSecs = (b.RootSize*32)/512;
        b.RootCat = b.ResSecs + (b.FatSize*b.FatCnt);
        b.StartData = b.RootCat+b.RootSecs;
        b.HiddenSecs = mmc_buffer[28];
        if(i ==  (int)mmc_buffer[28]) break;
        return(-1);        
      }
  }   
  return(b.HiddenSecs);
}

int fileSearch(char * file_name)
{
  int k, i, fptr;
  for(k = 0; k < b.RootSize/16; k++)
  { 
    mmcReadBlock((b.RootCat+k)*b.SectSize,512);
    for(i=0; i < 16; i++)
      {
        fptr=i*32;
        if((mmc_buffer[fptr] != 0xE5) && (mmc_buffer[fptr] !=0) &&
           ((mmc_buffer[fptr+0xb]&0x18) == 0))
          {
              if( strncmp( file_name, &mmc_buffer[fptr], 11) == 0 ) 
              return(i+(k*16));
          }
      }
  }
    return(-1);
}
 
int clValue(int cluster_number)
{ int k, n, iClust, vClust;
  extern int used_fat_sector;

   iClust = ((cluster_number<<1)+cluster_number)>>1;
   k=iClust>>9;
   iClust = iClust - (k<<9);
   if( k != used_fat_sector)
   {
      mmcReadBlock((b.ResSecs+k)*b.SectSize,512);
      for (n=0; n < 512; n++) fat_buffer[n] = mmc_buffer[n]; 
      used_fat_sector = k;
   }
          if ( iClust > 510 )
          {
            k++;
            mmcReadBlock((b.ResSecs+k)*b.SectSize,512);
            vClust = fat_buffer[511] | (mmc_buffer[0]<<8); 
          }
          else
          {
            vClust = fat_buffer[iClust] | fat_buffer[(iClust)+1]<<8;
          }
          if(cluster_number%2 == 0)
          {
            vClust = vClust & 0x0FFF;
          }
          else
          {
            vClust = vClust >>4;
          }

return (vClust);
}

int freeClustSearch( int StartCluster )
{  
   int  i; 

   for(i=StartCluster; i < (b.TotSecs/b.ClustSize); i++)
   {
     if(clValue(i) == 0) return(i);
   }

return(-1);

}

int fileCreate( char * file_name)
{
  int n, k, i, fptr;
  
  for(k = 0; k < b.RootSize/16; k++)
  { 
    mmcReadBlock((b.RootCat+k)*b.SectSize,512);//reading catalogue
    for(i=0; i < 16; i++)
      {
        fptr=i*32;
        if((mmc_buffer[fptr] == 0xE5) || (mmc_buffer[fptr] ==0)) 
        {
          strncpy( &mmc_buffer[fptr], file_name, 11 );
          mmc_buffer[fptr+0xb] = 0x20;
          for(n = 0xC; n <= 0x15; n++)  mmc_buffer[fptr+n]=0;         
          mmc_buffer[fptr+0x16] =  ((ctime.hour << 11) | ( ctime.minute << 5 ) | ctime.secunde/2) & 0xFF; 
          mmc_buffer[fptr+0x17] =  (((ctime.hour << 11) | ( ctime.minute << 5 ) | ctime.secunde/2) & 0xFF00)>>8;
          mmc_buffer[fptr+0x18] =  (((ctime.year-1980) << 9) | ( ctime.month << 5 ) | ctime.day) & 0xFF; 
          mmc_buffer[fptr+0x19] =  ((((ctime.year-1980) << 9) | ( ctime.month << 5 ) | ctime.day) & 0xFF00)>>8;
          mmc_buffer[fptr+0x1A] =  0; 
          mmc_buffer[fptr+0x1B] =  0;
          mmc_buffer[fptr+0x1C] =  0; 
          mmc_buffer[fptr+0x1D] =  0;
          mmc_buffer[fptr+0x1E] =  0; 
          mmc_buffer[fptr+0x1F] =  0;
          mmcWriteBlock((b.RootCat+k)*b.SectSize); //writing modified catalogue
          return((k*16)+i);
        }
      }
  }
return(-2);
}

int markCluster(int cluster_number, unsigned claster_value)
{
   int n, k, vClust, iClust; 

   k=((cluster_number<<1)+cluster_number)>>10;
//   for (n=0; n < 512; n++) tmp_buffer[n] = mmc_buffer[n]; 
   
   if( k != used_fat_sector)
   {
      mmcReadBlock((b.ResSecs+k)*b.SectSize,512);
      for (n=0; n < 512; n++) fat_buffer[n] = mmc_buffer[n]; 
      used_fat_sector = k;
   }
          iClust = ((cluster_number*3)/2)%512;
   
          if ( iClust > 510 )
          {
            k++;
            mmcReadBlock((b.ResSecs+k)*b.SectSize,512);
            vClust =fat_buffer[511] |(mmc_buffer[0] <<8);
          }
          else
          {
            vClust = fat_buffer[iClust] | fat_buffer[(iClust)+1]<<8;
          }
          //modification fat
          if(cluster_number%2 == 0)
          {
            vClust = (vClust & 0xF000) | claster_value;
          }
          else
          {
            vClust = (vClust & 0x000F) | (claster_value<<4);
          }
          
          
          if( k == used_fat_sector)
          {
            fat_buffer[iClust] = vClust & 0xFF;
            fat_buffer[iClust+1] = (vClust & 0xFF00)>>8;
          }
          else
          {
            mmc_buffer[0]=(vClust & 0xFF00)>>8;           
            mmcWriteBlock((b.ResSecs+k)*b.SectSize); //wirting fat1
            mmcWriteBlock((b.ResSecs+k+b.FatSize)*b.SectSize); //wirting fat2
            k--;
            fat_buffer[511] = vClust & 0xFF;
          }
      for (n=0; n < 512; n++) mmc_buffer[n] = fat_buffer[n]; 
      mmcWriteBlock((b.ResSecs+k)*b.SectSize); //wirting fat1
      mmcWriteBlock((b.ResSecs+k+b.FatSize)*b.SectSize); //wirting fat2
//      for (n=0; n < 512; n++) mmc_buffer[n] = tmp_buffer[n]; 
          
return(0);
  
}

tFILE * fileOpen(char * file_name, char mode)
{
  int n, k, vClust, tmp_word, fptr, cluster_number;
  tFILE * f;
//  extern struct tFILE fp[10];
//  f=(tFILE*) (&fp[0]);
  
  tmp_word=fileSearch(file_name);
  if( mode == 'c')
  {
    if( tmp_word >= 0) return(NULL);
    else tmp_word = fileCreate(file_name);
  }
  else  if( tmp_word < 0)  return(NULL);
  for(n=0; n < 10; n++) 
  {
    if( fp[n].id == 0 ) break;
  }
   f=&fp[n];
   f->id = tmp_word;
   k=tmp_word>>4;
   fptr=(tmp_word-(k<<4))<<5;
   mmcReadBlock((b.RootCat+k)*b.SectSize,512);
   f->size=(mmc_buffer[fptr+0x1F]<<24) | (mmc_buffer[fptr+0x1E]<<16) |
      (mmc_buffer[fptr+0x1D]<<8) | mmc_buffer[fptr+0x1C];
   f->current_cluster=f->first_cluster = (mmc_buffer[fptr+0x1B]<<8) + mmc_buffer[fptr+0x1A]; 
   f->current_sector=f->first_sector  = b.StartData + ((f->first_cluster-2)*b.ClustSize);
   f->current_offset=0;
   cluster_number = f->first_cluster;
   tmp_word=f->size;
  while(1)
  {
          vClust = clValue(cluster_number);       
    
          if(vClust >= 0xFF8)
          {
            f->last_cluster = cluster_number;
            break;
          }
          else if(vClust == 0x0)
          {
            return(NULL);
          }
          else
          {
            cluster_number = vClust;
            tmp_word-=b.ClustSize*b.SectSize;
            if(tmp_word < 0)
            {
              return(NULL);
            }
          }
  }      
   f->last_sector = (b.StartData + ((f->last_cluster-2)*b.ClustSize))
     +tmp_word/b.SectSize;
   f->last_offset = tmp_word%b.SectSize;
return(f);  
}

int fileRead(tFILE * f, char * string, int bytes)
{
  int i, k, next_cluster;  
  
  if((f->current_sector == f->last_sector) &&
     (f->current_offset >= f->last_offset))
    return(-1);
  
     mmcReadBlock(f->current_sector*b.SectSize,512);
    
    for( i=0, k=f->current_offset; i < bytes; i++)
    {
      if(k > 511)
      {
        f->current_sector++;
        if( ((f->current_sector-b.StartData)%b.ClustSize) == 0)
        {
           next_cluster=clValue(f->current_cluster);
           if (next_cluster >=0xFF8)  return(i);
           else f->current_cluster = next_cluster;
           f->current_sector = b.StartData + ((f->current_cluster-2)*b.ClustSize);
        }
        mmcReadBlock(f->current_sector*b.SectSize,512);
        k=0;
        f->current_offset =0;
      }
      string[i] = mmc_buffer[k];
      k++;
      if(string[i] == 0x0A)
      {
//        w0++;
        break; //break on end string
      }
      if(f->current_sector == f->last_sector)
      {
        if(k== f->last_offset)
        {
        break; // break on end of file
        }
      }
    }
    f->current_offset=k;
    return(i);
}


int fileWrite(tFILE * f, char * string, int bytes)
{
  int i, k, fptr, next_cluster;  
  
    if(f->size == 0)
    {
      next_cluster=freeClustSearch(0);
      if(next_cluster <= 0)
      {
        return(0);
      }
      else
      {
      markCluster(next_cluster, 0xFFF);

      f->first_cluster = f->last_cluster = f->current_cluster = next_cluster;      
      f->last_sector  = f->current_sector = b.StartData + ((f->current_cluster-2)*b.ClustSize);
      f->first_sector = f->last_sector;
      f->last_offset  = f->current_offset = 0;
      k=f->id>>4;
      fptr=(f->id-(k<<4))<<5;
      mmcReadBlock((b.RootCat+k)*b.SectSize,512);
      mmc_buffer[fptr+0x1A] =  f->first_cluster & 0x00FF; 
      mmc_buffer[fptr+0x1B] = (f->first_cluster & 0xFF00)>>8;
      mmcWriteBlock((b.RootCat+k)*b.SectSize);
      } 
    }
    mmcReadBlock(f->current_sector*b.SectSize,512);
    
    for( i=0, k=f->current_offset; i < bytes; i++)
    {
      if(k > 511)
      {
        mmcWriteBlock(f->current_sector*b.SectSize); //wirting sector
        f->current_sector++;
        if(((f->current_sector-b.StartData)%b.ClustSize) == 0)
        {
          
          next_cluster=freeClustSearch(f->current_cluster);
          if(next_cluster < 0)
          {
            f->size = f->size+i;
            f->last_offset=f->current_offset=k;
            f->last_sector=f->current_sector;
            f->last_cluster=f->current_cluster;
            goto exit; 
          }
          else
          {
            markCluster(f->current_cluster,next_cluster);
            markCluster(next_cluster, 0xFFF);
          }
          f->current_cluster = next_cluster;
          f->current_sector = b.StartData + ((f->current_cluster-2)*b.ClustSize);
        /*   next_cluster=clValue(f->current_cluster);
           if (next_cluster >=0xFF8)  return(i);
           else f->current_cluster = next_cluster;*/
        }
        mmcReadBlock(f->current_sector*b.SectSize,512);
        k=0;
      }
      mmc_buffer[k] = string[i];
      if(string[i] == 0x0)
      {
//        w1++;
        break;
      }
      k++;
    }
    mmcWriteBlock(f->current_sector*b.SectSize); //wirting sector
exit:
//    f->size = f->size+i+1;
    f->size = f->size+i;
    f->last_offset=f->current_offset=k;
    f->last_sector=f->current_sector;
    f->last_cluster=f->current_cluster;
    // modification catalogue!!
   k=f->id>>4;
   fptr=(f->id-(k<<4))<<5;
   mmcReadBlock((b.RootCat+k)*b.SectSize,512);
   mmc_buffer[fptr+0x16] =  ((ctime.hour << 11) | ( ctime.minute << 5 ) | ctime.secunde/2) & 0xFF; 
   mmc_buffer[fptr+0x17] =  (((ctime.hour << 11) | ( ctime.minute << 5 ) | ctime.secunde/2) & 0xFF00)>>8;
   mmc_buffer[fptr+0x18] =  (((ctime.year-1980) << 9) | ( ctime.month << 5 ) | ctime.day) & 0xFF; 
   mmc_buffer[fptr+0x19] =  ((((ctime.year-1980) << 9) | ( ctime.month << 5 ) | ctime.day) & 0xFF00)>>8;
   mmc_buffer[fptr+0x1C] =  f->size & 0x000000FF; 
   mmc_buffer[fptr+0x1D] = (f->size & 0x0000FF00)>>8;
   mmc_buffer[fptr+0x1E] = (f->size & 0x00FF0000)>>16;  
   mmc_buffer[fptr+0x1F] = (f->size & 0xFF000000)>>24;
   mmcWriteBlock((b.RootCat+k)*b.SectSize);
   return(i);
}

void fileReset(tFILE * f)
{
   f->current_cluster=f->first_cluster; 
   f->current_sector=f->first_sector;
   f->current_offset=0;
}
 
